#pragma once

#include "CoreMinimal.h"
#include "UniquelyIdentifiedAnalytic.h"
#include "MenuFlowTabData.h"
#include "MenuFlowButtonPressData.h"
#include "MenuFlowAnalytics.generated.h"

USTRUCT(BlueprintType)
struct FMenuFlowAnalytics : public FUniquelyIdentifiedAnalytic
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FString CurrentContext;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool CurrentContextIsUMG;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FString PreviousContext;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float TimeOnCurrentContext;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FString ContextChangeTimestamp;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FString MatchId;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FString LobbyId;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TArray<FMenuFlowTabData> Tabs;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TArray<FMenuFlowButtonPressData> Buttons;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FString StoreSessionGuid;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FString LobbySessionGuid;

public:
	DBDANALYTICS_API FMenuFlowAnalytics();
};

FORCEINLINE uint32 GetTypeHash(const FMenuFlowAnalytics) { return 0; }
